%define name    ka-deploy
%define version 0.92
%define release %mkrel 21
%define tftpbase tftpboot

Release:        %{release}
Version:        %{version}
Summary:        Ka-deploy cluster installation solution
Name:           %{name}
License:        GPL
Group:          System/Cluster
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Source:         %{name}.tar.bz2
Url:            http://kadeploy.imag.fr/
BuildRequires:	glibc-static-devel

%description
Ka-deploy is a tool for cloning large numbers of machines on a cluster

%package server-host
Summary:        Ka-deploy cluster installation solution - server host side
Group:          System/Cluster
Requires:       coreutils bind-utils, syslinux >= 1.67
License:        GPL

%description server-host
Ka-deploy is a tool for cloning large numbers of machines on a cluster
This package is to be installed on a server

%package source-node
Summary:        Ka-deploy cluster installation solution - source node side
Group:          System/Cluster
Requires:       coreutils
License:        GPL

%description source-node
Ka-deploy is a tool for cloning large numbers of machines on a cluster
This package is to be installed on the source node

%prep
%setup -q -n ka-deploy

%build
# remove all the CVS directories
rm -rf `find -type d -name "CVS"`

# compile
#du
cd src && make

%install
rm -Rf $RPM_BUILD_ROOT
#SERVER SIDE
mkdir -p $RPM_BUILD_ROOT/%{tftpbase}/ka
mkdir -p $RPM_BUILD_ROOT/%{tftpbase}/ka/pxelinux.cfg
mkdir -p $RPM_BUILD_ROOT/%{tftpbase}/ka/pxelinux.cfg/IP
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ka
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1

install -m 755 scripts/ka_pxe_step $RPM_BUILD_ROOT/%{tftpbase}/ka/ka_pxe_step
install -m 644 scripts/template  $RPM_BUILD_ROOT/%{tftpbase}/ka/pxelinux.cfg/template
install -m 644 scripts/ka.conf $RPM_BUILD_ROOT/etc/ka/ka.conf
install -m 644 scripts/ka.funcs $RPM_BUILD_ROOT/etc/ka/ka.funcs
ln -s pxelinux.cfg/template $RPM_BUILD_ROOT/%{tftpbase}/ka/template
#install -m 644 syslinux-1.67/pxelinux.0 $RPM_BUILD_ROOT/%{tftpbase}/ka/pxelinux.0
install -m 755 scripts/configure_server.sh $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/configure_server.sh
install -m 755 scripts/test_services.sh $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/test_services.sh
install -m 644 doc/ka-deploy.1 $RPM_BUILD_ROOT%{_mandir}/man1/ka-deploy.1

ln -s ka-deploy.1 $RPM_BUILD_ROOT%{_mandir}/man1/ka-d-server.1
ln -s ka-deploy.1 $RPM_BUILD_ROOT%{_mandir}/man1/ka-d-client.1

#install -m 644 kernel/vmlinuz-nfsroot $RPM_BUILD_ROOT/%{tftpbase}/ka/vmlinuz-nfsroot
#END OF SERVER SIDE

#BEGINING OF CLIENT SIDE
mkdir -p $RPM_BUILD_ROOT/usr/bin/
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d/
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ka

install -m 755 src/ka-d-server $RPM_BUILD_ROOT%{_bindir}/ka-d-server
install -m 755 src/ka-d-client $RPM_BUILD_ROOT%{_bindir}/ka-d-client
install -m 755 scripts/ka-d.sh $RPM_BUILD_ROOT%{_bindir}/ka-d.sh
install -m 755 scripts/bootable_flag.sh $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/fdisk_to_desc $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/gen_modprobe_conf.pl $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/ka-d.sh $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/ka_replication.sh $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/make_initrd_grub $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/make_initrd_lilo $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/prepare_node.sh $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/send_status.pl $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/status_node.pl $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/store_log.sh $RPM_BUILD_ROOT%{_bindir}/
# mke2fs built with dietlibc
install -m 755 scripts/mke2fs $RPM_BUILD_ROOT%{_bindir}/mke2fs_diet
install -m 755 scripts/replication.conf $RPM_BUILD_ROOT%{_sysconfdir}/ka

install -m 644 doc/ka-d.1 $RPM_BUILD_ROOT%{_mandir}/man1/ka-d.1
ln -s ka-d.1 $RPM_BUILD_ROOT%{_mandir}/man1/ka-d.sh.1
# END OF CLIENT SIDE



%clean
rm -rf $RPM_BUILD_ROOT

%post server-host
cp -f /usr/lib/syslinux/pxelinux.0 /%{tftpbase}/ka/pxelinux.0
# Add our IP address in the tftpserver file
#/sbin/ifconfig | grep -v 127.0.0.1 | grep "inet addr" | sed 's/^.*inet addr:\([^ ]*\) .*$/\1/g' | tail -n 1 > /%{tftpbase}/NFSROOT/tftpserver
# will be done by the configuration script

%files server-host
%defattr(-,root,root)

%doc README BUGS INSTALL doc 
%doc %{_mandir}/man1/ka-d-server.*
%doc %{_mandir}/man1/ka-d-client.*
%doc %{_mandir}/man1/ka-deploy.*

%config(noreplace) %{_sysconfdir}/ka
/%{tftpbase}/ka
%{_datadir}/%{name}-%{version}


%files source-node
%defattr(-,root,root)

%config(noreplace) %{_sysconfdir}/ka
%doc %{_mandir}/man1/ka-deploy.*
%doc %{_mandir}/man1/ka-d-server.*
%doc %{_mandir}/man1/ka-d.*

%{_bindir}/*
%{_datadir}/%{name}-%{version}



%changelog
* Tue Jun 17 2008 Thierry Vignaud <tvignaud@mandriva.com> 0.92-21mdv2009.0
+ Revision: 221764
- rebuild
- fix no-buildroot-tag
- kill (multiple!) definitions of %%buildroot on Pixel's request

* Thu Oct 25 2007 Antoine Ginies <aginies@mandriva.com> 0.92-20mdv2008.1
+ Revision: 102042
- move replication.conf to %%sysconfdir

* Thu Oct 25 2007 Antoine Ginies <aginies@mandriva.com> 0.92-19mdv2008.1
+ Revision: 102038
- udpate source, add mke2fs build with dietlibc
- merge patch (no more supported by inria), add various other scripts needed to do a full KA replication

* Thu Aug 23 2007 Thierry Vignaud <tvignaud@mandriva.com> 0.92-18mdv2008.0
+ Revision: 70278
- fileutils, sh-utils & textutils have been obsoleted by coreutils a long time ago

* Fri Jun 22 2007 Thierry Vignaud <tvignaud@mandriva.com> 0.92-17mdv2008.0
+ Revision: 43000
- fix group

* Thu May 31 2007 Adam Williamson <awilliamson@mandriva.com> 0.92-16mdv2008.0
+ Revision: 32998
- BuildRequires glibc-static-devel
- whoops: really fix ALL groups
- correct group (fixes #27317 and #27318)


* Sun Aug 13 2006 Nicolas Lcureuil <neoclust@mandriva.org> 0.92-14mdv2007.0
- Fix rpmlint warnings

* Fri Aug 11 2006 Erwan Velu <erwan@seanodes.com> 0.92-13mdk
- Rebuild

* Wed Apr 06 2005 <guibo@guibo.mdkc.com> 0.92-12mdk
- add cciss support

* Thu Mar 31 2005 <guibo@guibpiv.guibland.com> 0.92-11mdk
- fix pb of fdisk_commands

* Wed Mar 30 2005 Erwan Velu <erwan@seanodes.com> 0.92-10mdk
- Using -m32 & static flags

* Fri Apr 02 2004 Erwan Velu <erwan@mandrakesoft.com> 0.92-9mdk
- Rebuild

